#
# Makefile Template for Tessy
#
# Compiler   : Keil C51 (Keil Software Inc.)
# Environment: Keil Vision3 (Keil Software Inc.)
# Template Version : 1
#

# Defines to be generated by Tessy:
#
# TESSY_SYS					:=
# MODULE_PATH				:=
# TESTOBJECT				:=
# USER_LINK_OPTIONS		:=
# COMPILER_INSTALL_PATH	:=
# TARGET_INSTALL_PATH	:=

#####################################################################
#BEGIN_DEFINES
#####################################################################

TESSY_SYS_DOS   := $(shell ts_pathname -s $(TESSY_SYS))
MODULE_PATH_DOS := $(shell ts_pathname -s $(MODULE_PATH))
KEIL_HOME       := $(shell ts_pathname -rs '$(COMPILER_INSTALL_PATH)')
UVSC_HOME       := $(shell ts_pathname -rs '$(TARGET_INSTALL_PATH)')

TS_NAME         := TS_UVISION
IDE_NAME        := uvision_uvsc
COMPANY_NAME    := keil
PROCESSOR_NAME  := c51

all	   : master slave
master : $(MODULE_PATH)/ts_$(TESTOBJECT)_m.exe
slave  : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(BINARY_POSTFIX)


#

#
# MASTER & COMM Makefiles
# (you should not need to modify these settings)
#
M_COMM_MAKE     := $(TESSY_SYS)/make/master_$(IDE_NAME)_gnu_i386.mk
S_COMM_MAKE     := $(TESSY_SYS)/src/comm/comm_$(IDE_NAME)_$(COMPANY_NAME)_$(PROCESSOR_NAME).mk


#
# SLAVE
#
S_INCLUDES		:= $(TESSY_SYS_DOS)\include\tessy\comm
S_ASM_INCLUDES	:=	$(KEIL_HOME)\ASM
S_COMP_OPTIONS := LARGE DEBUG OT "(0)" BROWSE WARNINGLEVEL "(0)" REGPARMS NOPR OE DF(TS_SLAVE)
S_LINK_OPTIONS	:=

S_CC				:=	$(KEIL_HOME)/BIN/C51.EXE
S_ASM				:=	$(KEIL_HOME)/BIN/A51.EXE
S_LINK			:=	$(KEIL_HOME)/BIN/BL51.EXE
S_STUB_OBJECT  := $(MODULE_PATH_DOS)\ts_t_stubs$(OBJECT_POSTFIX)
S_UC_OBJECT    := $(MODULE_PATH_DOS)\ts_t_usr$(OBJECT_POSTFIX)

LOFLAGS			:= DW(16)
COMMA				:=	,


#####################################################################
#END_DEFINES
#####################################################################

# Targets to be defined by Tessy
#
# for each source
#
# S_SRC_OBJECTS      := $(MODULE_PATH)/ts_src01.o ... ts_srcnn.o
# USER_INCLUDES*     :=
# USER_COMP_OPTIONS* :=
#
# $(MODULE_PATH)/ts_src*.o : $(MODULE_PATH)/ts_src*.c
#		$(S_CC) $< $(S_COMP_OPTIONS) INCDIR($(S_INCLUDES);$(USER_INCLUDES*) ) $(USER_COMP_OPTIONS*)  OBJECT "($@)"

#####################################################################
#BEGIN_TARGETS
#####################################################################

S_SRC_LIST	:= $(foreach file,$(S_SRC_OBJECTS),$(addsuffix $(COMMA),$(file)))

#
# COPY USERCODE / STUBS / DRIVER
#
$(MODULE_PATH_DOS)\ts_t_usr.c : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr.c
	@ts_cp $< $@

$(MODULE_PATH_DOS)\ts_t_stubs.c : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs.c
	@ts_cp $< $@

$(MODULE_PATH_DOS)\ts_t_s.c : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.c
	@ts_cp $< $@


#
# COMPILE USERCODE / STUBS
#




$(S_UC_OBJECT) : $(MODULE_PATH_DOS)\ts_t_usr.c
	$(S_CC) $< $(S_COMP_OPTIONS) INCDIR($(S_INCLUDES)) OBJECT "($@)"

$(S_STUB_OBJECT) : $(MODULE_PATH_DOS)\ts_t_stubs.c
	$(S_CC) $< $(S_COMP_OPTIONS) INCDIR($(S_INCLUDES)) OBJECT "($@)"

#
# COMPILE/LINK MASTER
#

include $(M_COMM_MAKE)


#
# COMPILE SLAVE COMMUNICATION MODULES

include $(S_COMM_MAKE)




#
# COMPILE/LINK SLAVE
#

$(MODULE_PATH_DOS)\ts_start$(OBJECT_POSTFIX)	:	$(KEIL_HOME)\Lib\startup.a51
	$(S_ASM) $<  SET "(LARGE)" EP ID "($(S_ASM_INCLUDES))" OBJECT "($@)" NOPR

$(MODULE_PATH_DOS)\ts_t_s$(OBJECT_POSTFIX) : $(MODULE_PATH_DOS)\ts_t_s.c
	@echo *
	@echo ***** Copying Header Files *****
	@ts_cp $(S_INCLUDES)\tsteval.h $(MODULE_PATH_DOS)
	@ts_cp $(S_INCLUDES)\tstcomm_base.h $(MODULE_PATH_DOS)
	@ts_cp $(S_INCLUDES)\tessy_types.h $(MODULE_PATH_DOS)
	@echo ***** Compiling Slave *****
	$(S_CC) $< $(S_COMP_OPTIONS) INCDIR($(S_INCLUDES)) OBJECT "($@)"

$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(BINARY_POSTFIX) : $(MODULE_PATH_DOS)\ts_t_s$(OBJECT_POSTFIX) \
															$(S_SRC_OBJECTS) \
															$(S_UC_OBJECT) \
															$(S_STUB_OBJECT) \
															$(MODULE_PATH_DOS)\ts_start$(OBJECT_POSTFIX) \
															$(S_OBJECTS)
	@echo *
	@echo ***** Linking Slave *****
	@echo $(S_OBJECT_LIST) > $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin
	@echo $(MODULE_PATH_DOS)\ts_t_s$(OBJECT_POSTFIX), >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin
	@echo $(S_SRC_LIST) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin
	@echo $(S_UC_OBJECT), $(S_STUB_OBJECT), >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin
	@sh -c 'for f in $(USER_LINK_OPTIONS); do echo "$$f," >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin; done'
	@echo $(KEIL_HOME)\LIB\C51L.LIB >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin
	@echo TO $@ >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin
	@echo $(LOFLAGS) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin


	$(S_LINK) "@$(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lin"
	@-ts_rm "$(MODULE_PATH)"/*$(OBJECT_POSTFIX)



#####################################################################
#END_TARGETS
#####################################################################
